unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Buttons, Vcl.ExtCtrls, system.Diagnostics;

type
  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    Memo1: TMemo;
    BitBtn2: TBitBtn;
    LabeledEdit1: TLabeledEdit;
    Edit1: TEdit;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private 錾 }
    function Ninput(var n: integer): boolean;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

{  Seidel's algorithm for Tn
        0 1 2 3 4  5  6   7
   Tn = 1,1,1,2,5,16,61, 272       Tn n=2,4,6,8
                                               () for[v
n t[0] [1] [2] [3] [4] [5] [6]     ->
    1                             [0]=1         l
    1   1                     ->  [1]=[0]       upJn
2   1   1                     <-  [0]=[1]
    1   2   2                 ->  ([1]=[1]+[0]) [2]=[1]
4   5   5   4   2             <-  [3]=[2] ([2]=[3]+[1] [1]=[2]+[0]) [0]=[1]
    5  10  14  16  16         ->  ([1]=[1]+[0] ` [3]=[3]+[2]) [4]=[3]
6  61  61  56  46  32  16     <-  [5]=[4] ([4]=[5]+[3] ` [1]=[2]+[0]) [0]=[1]
   61 122 178 224 256 272 272 ->  ([1]=[1]+[0] ` [5]=[5]+[4]) [6]=[5]
}

uses Velthuis.BigIntegers;

const
  Ni = 3000;                              // őIC[No  Biginteger

// IC[vZ int64 n=22
procedure TForm1.BitBtn1Click(Sender: TObject);
const
  k = 22;
var
  t : array of int64;
  e : int64;
  j, m, n: integer;
  mstr : string;
  StopWatch : TStopwatch;
  ElapsedMillseconds : Int64;

  // l\
  procedure memoout;
  begin
    if e < 0 then mstr := ' = '
             else mstr := ' =  ';
    memo1.Lines.Append('E' + intTostr(n) + mstr + inttostr(e));
  end;

begin
  StopWatch := TStopwatch.StartNew;

  memo1.Clear;

  n := 0; e := 1; memoout;                      // E0

  // Seidel's algorithm for Tn
  setlength(t, k);                              // zm IC[n lNA
  t[0] := 1;
  for m := 1 to k shr 1 do begin                // for n=2 to k step 2  E2`
    n := m shl 1;                                           // n = m * 2
    for j := 1 to n - 2 do t[j] := t[j] + t[j - 1];         // ->  n=4s
    t[n - 1] := t[n - 2];
    for j := n - 2 downto 1 do t[j] := t[j + 1] + t[j - 1]; // <-  n=4s
    t[0] := t[1];

    e := t[0];                                // En = t[0]
    if (n + 2) mod 4 = 0 then e := -e;              // ݒ
    memoout;                                  // l\
  end;

  ElapsedMillseconds := StopWatch.ElapsedMilliseconds;
  Edit1.text := ' = ' + intTostr(ElapsedMillseconds) + 'msec';
end;


// IC[No͏
function TForm1.Ninput(var n: integer): boolean;
var
  c : integer;
begin
  result := true;
  val(labelededit1.Text, n, c);
  if c <> 0 then begin
    memo1.Text := 'IC[No ɊԈႢ܂B';
    result := false;
    exit;
  end;
  if n < 0 then begin
    memo1.Text := 'IC[No̓[ȏɂĉB';
    result := false;
  end;
  if n > NI then begin
    memo1.Text := 'IC[No 傫܂' + intTostr(NI) + 'łB';
    result := false;
  end;
end;

// IC[vZ@biginteger
procedure TForm1.BitBtn2Click(Sender: TObject);
const
  MM = 30;                                // ꗗ\ No
var
  t : array of biginteger;
  e : biginteger;
  j, m, n, k : integer;
  mstr : string;
  StopWatch : TStopwatch;
  ElapsedMillseconds : Int64;

  // l\
  procedure memoout;
  begin
    if e < 0 then mstr := ' = '
             else mstr := ' =  ';
    memo1.Lines.Append('E' + intTostr(n) + mstr + e.ToString);
  end;

begin
  if not Ninput(k) then exit;;
  StopWatch := TStopwatch.StartNew;

  memo1.Clear;

  if k <= MM then begin
    n := 0; e := 1; memoout;                        // E0
  end;
  if k < 1 then exit;

  // Seidel's algorithm for Tn
  setlength(t, k);                                  // z̊m IC[n lNA
  if (k <= MM) or ((k > MM) and (k mod 2 = 0)) then begin
    t[0] := 1;
    for m := 1 to k shr 1 do begin                  // for n=2 to k step 2  E2`
      n := m shl 1;                                             // n = m * 2
      for j := 1 to n - 2 do  t[j] := t[j] + t[j - 1];          // -> n=4s
      t[n - 1] := t[n - 2];
      for j := n - 2 downto 1 do  t[j] := t[j + 1] + t[j - 1];  // <- n=4s
      t[0] := t[1];

      e := t[0];                                                // En = t[0]
      if ((n <= MM) and (k <= MM)) or (k = n) then begin
        if (n + 2) mod 4 = 0 then e := -e;                // ̐ݒ
        memoout;                                    // l\
      end;
    end;
  end;
  if k mod 2 <> 0 then begin                        //  0 \
     n := k; e := 0; memoout;
  end;

  ElapsedMillseconds := StopWatch.ElapsedMilliseconds;
  Edit1.text := ' = ' + intTostr(ElapsedMillseconds) + 'msec';
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  labeledEdit1.EditLabel.Caption := 'En n<=' + intTostr(NI);
end;

end.
